//      attempt at a Trace() implementation macro by [GDS|Entropy]
#include "slopeSnowTex.inc"
#version unofficial megapov 1.21;

global_settings {
 assumed_gamma 1.0
}

camera {
 location <-5, 6,-36>
 up y*image_height right x*image_width
 look_at < 0, 1.5, 0>
 angle 45
} 

light_source {
 0*x
 color rgb <0.2734, 0.5078, 0.7031>  
 area_light
 <100, 0, 0> <0, 0, 100> 
 4, 4                
 adaptive 0          
 jitter              
 translate <0,1000,-2000>   
}

#local RsA = seed(574647);

//      RRand Macro by Chris Huff
#macro RRand(RS, Min, Max) (rand(RS)*(Max-Min) + Min) #end 

//      randVect Macro by [GDS|Entropy]
//------

#macro randVector(Array,ctr,Min,Max,Method)
 #local i=0;
 #while (i<ctr)
  #switch (Method)
   #case (0)    
    #declare Array[i] = <RRand(RsA, Min, Max),RRand(RsA, Min, Max),RRand(RsA, Min, Max)>;
   #break
   #case (1)
    #declare Array[i] = <sin(RRand(RsA, Min, Max)),RRand(RsA, Min, Max),tan(RRand(RsA, Min, Max))>;
   #break    
   #case (2)
    #declare Array[i] = <sin(RRand(RsA, Min, Max)),atanh(RRand(RsA, Min, Max)),tan(RRand(RsA, Min, Max))>;
   #break    
   #case (3)
    #declare Array[i] = <asin(RRand(RsA, Min, Max)),atanh(RRand(RsA, Min, Max)),tan(RRand(RsA, Min, Max))>;
   #break
   #case (4)
    #declare Array[i] = <acosh(RRand(RsA, Min, Max)),asinh(RRand(RsA, Min, Max)),tan(RRand(RsA, Min, Max))>;
   #break
   #case (5)
    #declare Array[i] = <cos(i),i,sin(i)>;
   #break
  #end  
 #set i=i+1;
 #end
#end

//------

//      Textures
#declare IOR = 1.45;
#declare Fade_Distance = 2;
#declare Fade_Power = 3;

#declare InteriorX =
 interior {
  fade_distance Fade_Distance
  fade_power Fade_Power
  ior IOR
  caustics 1.0
 }

#declare FinishX =
 finish {
  diffuse 0.000001
  reflection 0.5
  specular 1
  brilliance 5
  metallic on
  ambient 0.5
  roughness 0.001  
 }

#declare FinishY =
 finish {
  diffuse 0.000001
  reflection 0.5
  specular 1
  brilliance 5
  metallic on  
 }
//------

//      testSphere Macros by [GDS|Entropy]
#macro testSphere0(vect,diameter)
 sphere {
  vect,diameter
  texture {
   pigment {
    color rgb vect
    filter 1
   }
   finish {
    FinishY
   } 
  }
  interior {
   InteriorX
  }     
 }
#end

#macro testSphere1(vect,diameter)
 sphere {
  vect,diameter
  texture {
   pigment {
    color rgb vect
    filter 0
   }
   finish {
    FinishX
   }
  } 
  interior {
   InteriorX
  }     
 }
#end
//------

slopeSnowTex(-1,0.9) 

//      icicleTest Macro by [GDS|Entropy]
#macro icicleTest(ctr,posArray,diaArray,radVal,strVal,useInterior)
 blob { 
     #local k=0;
     #while (k<ctr)
      sphere {
       posArray[k], diaArray[k]+radVal, strVal
       pigment {color rgb <0,0.5,0>}   
       /*texture {
        Ice2
       } */
      } 
     #set k=k+1;
     #end /*    
 #if (useInterior)
  interior {
   fade_distance 2
   fade_power 3
   ior 1.45
   caustics 1.0 
  }
 #end */ 
 } 
#end
//------

//      icicleVectTest Macro by [GDS|Entropy]
#macro icicleVectTest(ctr,posArray,diaArray,vectorArray,testVector,testObject,prevTestObject,radVal,strVal,useInterior)
 #local vectorA = min_extent(testObject);
 #local vectorB = max_extent(testObject);
//box {vectorA,vectorB pigment {color rgbt <0.5,0.75,0.5,0.9>}} 
 #local vectorC = min_extent(prevTestObject);
 #local vectorD = max_extent(prevTestObject);
//box {vectorC,vectorD pigment {color rgbt <0,0,0.75,0.9>}}  
   
 #local i=0;
 #while (i<ctr)
  #if (((vectorArray[i].x <= vectorD.x) & (vectorArray[i].x >= vectorC.x)) & ((vectorArray[i].y <= vectorD.y) & (vectorArray[i].y >= vectorC.y)) & ((vectorArray[i].z <= vectorD.z) & (vectorArray[i].z >= vectorC.z)))     
   //#debug "\n inside old bb"
  #else
   //#debug "\n outside old bb"
   #if (((vectorArray[i].x <= vectorB.x) & (vectorArray[i].x >= vectorA.x)) & ((vectorArray[i].y <= vectorB.y) & (vectorArray[i].y >= vectorA.y)) & ((vectorArray[i].z <= vectorB.z) & (vectorArray[i].z >= vectorA.z)))
    //#debug "\n inside new bb"
    #local trace0 = trace(testObject,vectorArray[i],testVector);
    #if (((trace0.x <= vectorD.x) & (trace0.x >= vectorC.x)) & ((trace0.y <= vectorD.y) & (trace0.y >= vectorC.y)) & ((trace0.z <= vectorD.z) & (trace0.z >= vectorC.z)))
     //#debug "\n trace0 inside old bb"
    #else
     //#debug "\n trace0 outside old bb"
     #local k=0;
     #while (k<ctr)
       #local icicleLength = vlength(<trace0.x+RRand(RsA, 0.125, 0.25)-0.25,-(trace0.y-(1*0.132)),trace0.z+RRand(RsA, 0.125, 0.25)-0.25>-<trace0.x+RRand(RsA, 0.125, 0.25)-0.25,-(trace0.y-(ctr*0.132)),trace0.z+RRand(RsA, 0.125, 0.25)-0.25>);
       //#debug concat("Length of icicles", vstr(3,icicleLength,",",3,3),"\n")
       #declare posArray[k] = <trace0.x+RRand(RsA, 0.125, 0.25)-0.25,-((trace0.y-(k*0.132))+(icicleLength-(1+RRand(RsA, 0.75, 0.85)))),trace0.z+RRand(RsA, 0.125, 0.25)-0.25>;
       //#declare posArray[k] = <trace0.x+RRand(RsA, 0.125, 0.25),(trace0.y-(k*0.132)),trace0.z+RRand(RsA, 0.125, 0.25)>;
       #declare diaArray[k] = ((cos(k)*atan(0.125*sqrt(abs(k))))-RRand(RsA, 0.25, 0.5));               
     #set k=k+1;
     #end
     icicleTest(ctr,posArray,diaArray,0.25,1,yes)     
    #end    
   #end
  #end                                           
 #set i=i+1;
 #end 
#end
//------

//      snowTest Macro by [GDS|Entropy]
#macro snowTest(ctr,vectorArray,testVector,testObject,radVal,strVal,useInterior)
 #local vectorA = min_extent(testObject);
 #local vectorB = max_extent(testObject);
 //box {vectorA,vectorB pigment {color rgb 1}}
 #declare snowCap = 
 blob { 
 #local i=0;
 #while (i<ctr)     
  #if (((vectorArray[i].x <= vectorB.x) & (vectorArray[i].x >= vectorA.x)) & ((vectorArray[i].y <= vectorB.y) & (vectorArray[i].y >= vectorA.y)) & ((vectorArray[i].z <= vectorB.z) & (vectorArray[i].z >= vectorA.z)))
   #if (inside(testObject,vectorArray[i]))
    sphere {
     trace(testObject,vectorArray[i],testVector), radVal-RRand(RsA, 0.125, 0.25), strVal
     pigment {color rgb vectorArray[i]}
     /*texture {
      SnowTex0
     }*/     
    } 
   #end  
  #end                                           
 #set i=i+1;
 #end/*
 #if (useInterior)
  interior {
   fade_distance 2
   fade_power 3
   ior 1.45
   caustics 1.0 
  } 
 #end*/ 
 }

object {
 snowCap
}

#end
//------


//      test objects
#declare objA =
torus { 
 1, 0.5 
 translate <0,0,0>
 rotate <90,0,0>
 scale 2
 texture {
  pigment {
   color rgb <145/255,102/255,32/255>
  }
 }
 finish { 
  ambient 0 
  diffuse 1 
  specular 0.5 
  roughness 0.01 
  reflection 0.03 
 }
 normal { 
  wrinkles 0.2 
  scale 0.5 
 }  
}

#declare objB =
cone { 
 <0, 1, 0>, 0.0, <0, -1, 0>, 1.0 
 scale 2
}

#declare objC = 
quartic {
 < 0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.01,
   0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   0.0,  0.0,  0.01, 0.0, -0.01 >
  bounded_by { sphere { <0, 0, 0>, 2 } }
  scale 2
}
//------

#declare Sp = 5000;
#declare randVectArray = array [Sp];
randVector(randVectArray,Sp,-4,4,0)

#declare snowyObject = 
union {
 snowTest(Sp,randVectArray,<0,12,0>,objA,1,1,yes)
 object {
  objA 
 }
}

#declare SpX = 500;
#declare randVectArrayX = array [SpX];
randVector(randVectArrayX,SpX,-4,4,0)

#declare SpY = 100;
#declare posVectArrayY = array [SpY];
#declare diaVectArrayY = array [SpY];
#declare icicles = union {icicleVectTest(SpY,posVectArrayY,diaVectArrayY,randVectArrayX,<0,-12,0>,snowyObject,objA,0.25,1,yes)};

union {
object {
 snowyObject
}
object {
 icicles
}
translate 5*y
}