//---------------------------------------//
//      Snow texture by [GDS|Entropy]    |
//                       Ian McDonald    |    
//---------------------------------------//

#macro slopeSnowTex(_C_,filterVal)

#declare Snow =
texture {
 pigment {
  color rgb <0.96,0.97,0.99>*1.1
 }
 normal {
  wrinkles 0.4 
  ramp_wave 
  turbulence 0.3 
  scale 0.039
 }
 finish {
  ambient 0.35 
  diffuse 0.425 
  specular 0.125 
  roughness 0.1
 }
}

#declare Snow2 =
texture {
 pigment {
  color rgb <0.98,0.97,0.96>
 }
 normal {
  wrinkles 0.3 
  ramp_wave 
  turbulence 0.25 
  scale 0.036
 }
 finish {
  ambient 0.325 
  diffuse 0.4 
  specular 0.15 
  roughness 0.075
 }
}

#declare Ice = 
texture {
 pigment {
  bozo 
  octaves 1 
  frequency 4 
  triangle_wave
  color_map { 
   [0.00 rgbf <0.98,0.97,0.96,filterVal>]
   [0.03 rgbf <0.91,0.97,0.93,filterVal>]
   [0.40 rgbf <0.91,0.97,0.93,filterVal>]
   [0.40 rgbf <0.91,0.94,0.94,filterVal>]
   [0.42 rgbf <0.91,0.97,0.93,filterVal>]
   [1.00 rgbf <0.91,0.97,0.93,filterVal>]
  }
 }
 finish { 
  ambient 0 
  diffuse 1 
  brilliance 0.005 
  specular 0.5 
  roughness 0.001 
  reflection 0.125 
 }
 normal { 
  wrinkles 0.1 
  scale 0.00001 
 } 
}

#declare Ice2 = 
texture {
 pigment {
  bozo 
  octaves 1 
  frequency 4 
  triangle_wave
  color_map { 
   [0.00 rgbt <0.98,0.97,0.96,filterVal+0.1>]
   [0.03 rgbt <0.91,0.97,0.93,filterVal+0.1>]
   [0.40 rgbt <0.91,0.97,0.93,filterVal+0.1>]
   [0.40 rgbt <0.91,0.94,0.94,filterVal+0.1>]
   [0.42 rgbt <0.91,0.97,0.93,filterVal+0.1>]
   [1.00 rgbt <0.91,0.97,0.93,filterVal+0.1>]
  }
 }
 finish { 
  ambient 0 
  diffuse 1 
  brilliance 0.05 
  specular 0.5 
  roughness 0.001 
  reflection 0.125 
 }
 normal { 
  wrinkles 0.1 
  scale 0.00001 
 } 
}

 
#declare SnowTex0 =
texture {
  slope -y
  texture_map {
    [0.1 Snow]
    [0.2-(0.05*_C_) Snow2]
    [0.3-(0.01*_C_) Ice]
    [0.4-(0.133*_C_) Ice2]
    [0.5-(0.133*_C_) Ice2]
  } 
  rotate -5*z
}
#end